////////////////
// App.PlaySound
var player = null;

app.PlaySound = function( file ) {
    
    if( player == null)
    {
        player = app.CreateMediaPlayer();
        player.SetOnReady( player_OnReady );
    }
    
    player.SetFile( file );
}

function player_OnReady()
{
    player.Play();
}
// App.PlaySound
////////////////

//////////////
// App.Explode
var exp_player = null;

app.Explode = function() {
    
    layExp = app.CreateLayout( "Linear", "VCenter, FillXY, Center" );   
    imgExp = app.CreateImage( null, 0.5, 0.6 );
    layExp.AddChild( imgExp );
    app.AddLayout( layExp );
    exp_player = app.CreateMediaPlayer();
	exp_player.SetFile( "/Sys/Snd/Explode.mp3" );
	exp_player.SetOnReady( exp_player_OnReady );
    Explode( 0 );
}

//Show an animated explosion.
function Explode( startFrame )
{
    if( startFrame!=null )
    {
        explodeFrame = startFrame;
    }
    
	if( explodeFrame < 5 ) 
	{
		var file = "Explode" + (++explodeFrame) + ".png";
		imgExp.SetImage( "/Sys/Img/" + file, 0.5, 0.6 );
		setTimeout( Explode, 100 );
	}
	else 
	{ 
		explodeFrame = 1;
		app.DestroyLayout( layExp );
		exp_player.Release();
	}
}

//Play explosion sound and vibrate.
function exp_player_OnReady()
{
	exp_player.Play();
	app.Vibrate( "100,80" );
}

// App.Explode
//////////////

///////////
// Img.Spin
function Spin( imgSpin, duration ) {
    
    // Seconds to milliseconds
    duration *= 1000;
    var frames = Math.round( duration / 25 );
    var angleInc = 360 / frames;
    
    var startAngle = (imgSpin.rotation != null) ? imgSpin.rotation : 0;
    
    SpinImage( imgSpin, frames, angleInc, startAngle );
}

function SpinImage( imgSpin, frames, angleInc, startAngle )
{
    if( frames > 0 )
    {
        var rotation = (startAngle + angleInc) % 360;
        imgSpin.Rotate( rotation, 0.5, 0.5 );
        setTimeout( function() {
                SpinImage( imgSpin, --frames, angleInc, rotation );
            }, 25 );
    }
}

// Img.Spin
///////////
