
function sim_ajaxGet(n, t, i, r) {
    n == "SmartScript" ? sim_smartScript(t, i, r) : alert("Unknown simType!")
}
function sim_smartScript(n, t) {
    var o, f, s, u;
    if (n.url.indexOf("/ide?") > -1) {
        var e = n.url.split("?")
          , r = e[1].split("&")
          , i = getParam(r, "cmd");
        i == "getinfo" ? (o = null,
        t('{"status":"ok", "lastprog":"' + o + '", "appname":"DroidScript"}')) : i == "getsamples" ? t('{ "samples":"demo1"}') : i == "list" ? (f = getParam(r, "dir"),
        f ? t('{ "list":["' + f + '.js"] }') : t('{ "list":["test"] }')) : i == "add" ? (u = getParam(r, "prog"),
        s = getParam(r, "type"),
        document.ide.add(u, s),
        t('{"status":"ok"}')) : i == "run" ? (u = getParam(r, "prog"),
        document.ide.run(u)) : i == "stop" ? (u = getParam(r, "prog"),
        document.ide.stop(u),
        t('{"status":"ok"}')) : (alert("Unknown IDE command: " + i),
        t('{"status":"unknown command"}'))
    } else {
        var e = n.url.split("8088/")
          , h = e[1]
          , c = document.ide.get(h);
        t(c)
    }
}
function getParam(n, t) {
    for (var r, i = 0; i < n.length; i++)
        if (r = n[i].split("="),
        r.length > 1 && r[0] == t)
            return r[1];
    return null
}
function ChromeApp() {
    this.broadcastSocket = null;
    this.initialised = !1;
    this.deviceId = ""
}
function UDPSocket() {
    this.socketId = -1
}
function AceEditor(n) {
    this.initialised = !1;
    this.editor = null;
    this.onChangeFunc = null;
    this.$onTokensChanged = null;
    this.$onDocumentChanged = null;
    this.domElement = null;
    this.functionDropdown = typeof n != "undefined" ? n : null
}
function getObjType(n, t) {
    var i, r;
    return n == "app" ? g_types.App : (i = t.search(new RegExp("\\b" + n + "\\s*=.*Create(.+)[(]")),
    i < 0) ? null : (r = RegExp.$1.replace(" ", ""),
    g_types[r])
}
function getObjFunctions(n) {
    var t = g_objFunctionCache[n], r, u, i;
    if (typeof t == "undefined") {
        r = new window[n];
        t = [];
        u = g_ignoreFuncs[n] || [];
        for (i in r)
            r.hasOwnProperty(i) && typeof r[i] == "function" && u.indexOf(i) == -1 && t.push(i);
        t.sort();
        g_objFunctionCache[n] = t
    }
    return t
}
function BlocklyEditor() {
    this.initialised = !1;
    this.onChangeFunc = null;
    this.onChangeBindData = null;
    this.domElement = null;
    this.readOnly = !1;
    this.workspace = null
}
function CreateEditorFile(n) {
    var t = n.split(".")[1];
    return t === "dsj" ? _createBlocklyEditorFile(n) : _createAceEditorFile(n)
}
function _createAceEditorFile(n) {
    var t = new DroidScriptEditorFile(n);
    return t.session = null,
    t.functions = [],
    t.errorMarkers = [],
    t.editor = codeEditor,
    t.isOpen = function() {
        return this.session != null
    }
    ,
    t.getValue = function() {
        return this.session.getValue()
    }
    ,
    t.setValue = function(n) {
        var t = new Document(n)
          , i = getAceMode(this.getType());
        this.session = new EditSession(t,i);
        this.session.setUseWorker(!1);
        this.session.setUndoManager(new UndoManager)
    }
    ,
    t.save = function(n) {
        return createFile(n, this.session.getValue())
    }
    ,
    t.close = function() {
        this.functions = [];
        this.session = null;
        this.modified = !1;
        this.errorMarkers = []
    }
    ,
    t.clearAnnotations = function() {
        if (this.session != null) {
            this.session.clearAnnotations();
            for (var n = 0; n < this.errorMarkers.length; ++n)
                this.session.removeMarker(this.errorMarkers[n])
        }
        this.errorMarkers = []
    }
    ,
    t
}
function _createBlocklyEditorFile(n) {
    var t = new DroidScriptEditorFile(n);
    return t.workspace = null,
    t.javascript = null,
    t.editor = blocklyEditor,
    t.isOpen = function() {
        return this.workspace != null
    }
    ,
    t.getValue = function() {
        return this.workspace
    }
    ,
    t.setValue = function(n) {
        this.workspace = n
    }
    ,
    t.save = function(n) {
        var t = n.replace(".dsj", ".js");
        return createFile(n, this.workspace) && createFile(t, this.javascript)
    }
    ,
    t.close = function() {
        this.workspace = null;
        this.modified = !1
    }
    ,
    t.clearAnnotations = function() {}
    ,
    t
}
function DroidScriptEditorFile(n) {
    this.filename = n;
    this.displayName = n.split(".")[0];
    this.modified = !1;
    this.tabId = uniqueTabIdCounter++;
    this.canDelete = !1;
    this.editor = null
}
function isSupportedFileType(n) {
    var t = n.substr(n.lastIndexOf(".") + 1);
    return supportedFileExtensions.indexOf(t.toLowerCase()) >= 0
}
function getAceMode(n) {
    n = n.toLowerCase();
    var t = "ace/mode/text";
    return n.localeCompare("js") == 0 ? t = "ace/mode/javascript" : n.localeCompare("htm") == 0 || n.localeCompare("html") == 0 ? t = "ace/mode/html" : n.localeCompare("css") == 0 ? t = "ace/mode/css" : n.localeCompare("json") == 0 ? t = "ace/mode/json" : n.localeCompare("xml") == 0 && (t = "ace/mode/xml"),
    t
}
function getDefaultFileContent(n) {
    var t = n.substr(n.lastIndexOf(".") + 1)
      , i = "";
    return t.localeCompare("htm") == 0 || t.localeCompare("html") == 0 ? i = "<html>\n\t<head>\n\t\t<title>Hello World!<\/title>\n\t<\/head>\n\t<body>\n\t\t<p>Hello World!<\/p>\n\t<\/body>\n<\/html>" : t.localeCompare("css") == 0 && (i = "body\n{\n\n}"),
    i
}
function setBusy(n) {
    n ? busyStack++ == 0 && (clearTimeout(busySpinnerOffTimer),
    busySpinnerOnTimer = setTimeout(function() {
        $("#busyOverlay").fadeIn()
    }, 250)) : --busyStack == 0 && (clearTimeout(busySpinnerOnTimer),
    busySpinnerOffTimer = setTimeout(function() {
        $("#busyOverlay").fadeOut()
    }, 250))
}
function loadHomePage() {
    $("#homeView").attr("src", "http://www.androidscript.org/Home/home.html?demos=true")
}
function onReceiveMessage(n) {
    var t, i;
    n.origin === "http://www.androidscript.org" && (n.data == "homePageReady" ? (clearTimeout(homePageErrorTimeout),
    $("#homeView").css("width", "100%"),
    $("#homeView").css("height", "100%"),
    $("#homeErrorPage").hide()) : (t = n.data.split("|"),
    t.length == 2 && t[0] === "downloadspk" && (i = decodeURIComponent(t[1]).replace(/^.*[\\\/]/, ""),
    $("#okCancelDialogOkButton").off("click").click(function() {
        ajaxGet({
            url: getServerUrl("ide?cmd=downloadspk&url=" + encodeURIComponent(t[1]))
        })
    }),
    $("#okCancelDialogHeader").text("Install SPK"),
    $("#okCancelDialogMessage").text("Click OK to download " + i + " and follow the instructions on your Android device."),
    $("#okCancelDialog").modal("show"))))
}
function onEditorResize() {
    var n = $("#editorTabs").outerHeight(!0)
      , t = $("#editorToolBar").outerHeight(!0);
    $("#editor").css("top", n + t);
    $("#blocklyEditor").css("top", n + t);
    $("#editorTabs").data("tabdrop") != null && $("#editorTabs").data("tabdrop").layout()
}
function initIDE() {
    codeEditor = new AceEditor($("#functionDropdown"));
    codeEditor.init(document.getElementById("editor"), !1);
    codeEditor.addChangeListener(function() {
        if (AppList.getOpenApp() != null) {
            var n = AppList.getOpenApp().activeEditorFile;
            setModified(n, !0)
        }
    });
    sampleEditor = new AceEditor;
    sampleEditor.init(document.getElementById("sampleEditor"), !0);
    blocklyEditor = new BlocklyEditor;
    blocklyEditor.init(document.getElementById("blocklyEditor"), !1);
    blocklyEditor.addChangeListener(function() {
        if (AppList.getOpenApp() != null) {
            var n = AppList.getOpenApp().activeEditorFile;
            setModified(n, !0);
            n.workspace = blocklyEditor.getWorkspace();
            n.javascript = blocklyEditor.getJavaScript()
        }
    });
    sampleBlocklyEditor = new BlocklyEditor;
    sampleBlocklyEditor.init(document.getElementById("sampleBlocklyEditor"), !0);
    codeEditor.hide();
    blocklyEditor.hide()
}
function updateTooltips() {
    $("[data-toggle=tooltip]").tooltip({
        container: "body"
    })
}
function showEditorError(n) {
    var i;
    n = n.replace("Script Error: ", "");
    var u = n.split("|")
      , r = u[1] - 1
      , f = decodeURIComponent(u[2].replace(/^.*[\\\/]/, ""))
      , t = null;
    for (i = 0; i < AppList.getOpenApp().editorFiles.length; ++i)
        if (AppList.getOpenApp().editorFiles[i].filename == f) {
            t = AppList.getOpenApp().editorFiles[i];
            break
        }
    t && loadEditorFile(t, AppList.getOpenApp()).then(function() {
        t.session.setAnnotations([{
            row: r,
            column: 0,
            text: u[0],
            type: "error"
        }]);
        var n = new Range(r,0,r,Infinity);
        t.errorMarkers.push(t.session.addMarker(n, "ace_error-marker", "line"));
        $('#editorTabs a[href="' + t.tabId + '"]').tab("show");
        codeEditor.scrollToLine(r)
    })
}
function onExpand() {
    $("#leftPanel").hasClass("span6") ? ($("#leftPanel").removeClass("span6"),
    $("#leftPanel").addClass("span8"),
    $("#rightPanel").removeClass("span6"),
    $("#rightPanel").addClass("span4"),
    $("#expBtn img").attr("src", "resources/collapse.png"),
    $("#expBtn").attr("title", "Collapse Editor").tooltip("fixTitle").tooltip("show")) : ($("#leftPanel").removeClass("span8"),
    $("#leftPanel").addClass("span6"),
    $("#rightPanel").removeClass("span4"),
    $("#rightPanel").addClass("span6"),
    $("#expBtn i").removeClass(),
    $("#expBtn i").addClass(),
    $("#expBtn img").attr("src", "resources/expand.png"),
    $("#expBtn").attr("title", "Expand Editor").tooltip("fixTitle").tooltip("show"));
    codeEditor.resize();
    blocklyEditor.resize();
    sampleEditor.resize();
    sampleBlocklyEditor.resize();
    $("#editorTabs").data("tabdrop").layout()
}
function onToggleJS() {
    $("#blocklyEditor").is(":visible") ? (codeEditor.setValue(blocklyEditor.getJavaScript()),
    codeEditor.setReadOnly(!0),
    codeEditor.moveCursorTo(0, 0),
    codeEditor.show(),
    blocklyEditor.hide()) : (codeEditor.hide(),
    blocklyEditor.show())
}
function onToggleSampleJS() {
    $("#sampleBlocklyEditor").is(":visible") ? (sampleEditor.setValue(sampleBlocklyEditor.getJavaScript()),
    sampleEditor.setReadOnly(!0),
    sampleEditor.moveCursorTo(0, 0),
    sampleEditor.show(),
    sampleBlocklyEditor.hide()) : (sampleEditor.hide(),
    sampleBlocklyEditor.show())
}
function logDebugMessage(n) {
    var i = $("<li>" + n + "<\/li>"), t = $("#debugFilter").val().trim(), r;
    t.length > 0 && (t = t.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&"),
    r = new RegExp(t,"i"),
    r.test(i.text()) || i.hide());
    $("#debugList").append(i);
    scrollDebugLogToBottom()
}
function logServiceMessage(n) {
    var t = n.replace("svc:", "");
    logDebugMessage("<span style='color: gray'>" + t + "<\/span>")
}
function logDebugError(n) {
    var i = n, t, r;
    n.indexOf("Script Error:") > -1 && (t = n.split("|"),
    t.length == 3 && (i = t[0].replace(/&/g, "&amp;").replace(/"/g, "&quot;").replace(/</g, "&lt;").replace(/>/g, "&gt;"),
    r = t[2].replace(/^.*[\\\/]/, ""),
    r.indexOf("~") != 0 && (i += ", Line " + t[1],
    i += ", " + r)));
    logDebugMessage("<span style='color: red'>" + i + "<\/span>")
}
function clearDebugLog() {
    $("#debugList").empty()
}
function scrollDebugLogToBottom() {
    var n = $("#debugList").outerHeight(!0);
    $("#debugPanel").scrollTop(n)
}
function onDebugFilter() {
    var n = $("#debugFilter").val().trim(), t;
    n.length == 0 ? $("#debugList li").each(function() {
        $(this).show()
    }) : (n = n.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&"),
    t = new RegExp(n,"i"),
    $("#debugList li").each(function() {
        t.test($(this).text()) ? $(this).show() : $(this).hide()
    }));
    scrollDebugLogToBottom()
}
function webSocketIsConnected() {
    return webSocket != null && (webSocket.readyState == 0 || webSocket.readyState == 1)
}
function openWebSocket() {
    webSocketIsConnected() || (window.WebSocket ? (webSocket = new WebSocket(getServerWSUrl("")),
    webSocket.onopen = webSocket_onopen,
    webSocket.onmessage = webSocket_onmessage,
    webSocket.onclose = webSocket_onclose,
    webSocket.onerror = webSocket_onerror) : logDebugError("WebSocket not supported by this browser, the debug window will not be available."))
}
function webSocket_onopen() {
    logDebugMessage("[Connected]");
    $("#ideConnected").show();
    $("#ideDisconnected").hide();
    var n = "<img src='resources/connected.png'/> Connected to " + serverInfo.devicename;
    $("#ideConnected").popover("destroy");
    $("#ideConnected").popover({
        html: !0,
        placement: "left",
        trigger: "hover",
        content: n
    });
    $("#ideConnected").popover("show");
    setTimeout(function() {
        $("#ideConnected").popover("hide")
    }, 4e3);
    webSocket.send("debug");
    webSocketKeepAliveTimer = setInterval(function() {
        console.log("sending keepalive");
        webSocket.send("keepalive")
    }, 5e3)
}
function webSocket_onmessage(n) {
    var t = n.data;
    t.indexOf("Script Error") > -1 ? (logDebugError(t),
    showEditorError(t)) : t.indexOf("svc:") > -1 ? logServiceMessage(t) : logDebugMessage(t)
}
function webSocket_onclose() {
    function n(t) {
        if (t == 4) {
            onRequestError();
            return
        }
        connect(serverIPAddress).then(function() {
            refreshAppsList()
        }, function(i) {
            i == "PasswordError" ? (serverPass = "",
            n(++t)) : onRequestError()
        })
    }
    logDebugMessage("[Disconnected]");
    $("#ideDisconnected").show();
    $("#ideConnected").hide();
    $("#ideDisconnected").popover("destroy");
    $("#ideDisconnected").popover({
        html: !0,
        placement: "left",
        trigger: "hover",
        content: "Disconnected. Click <img src='resources/disconnected.png'/> to reconnect"
    });
    $("#ideDisconnected").popover("show");
    setTimeout(function() {
        $("#ideDisconnected").popover("hide")
    }, 4e3);
    $("#ideDisconnected").off("click").on("click", function() {
        n(0)
    });
    clearInterval(webSocketKeepAliveTimer);
    webSocketKeepAliveTimer = null
}
function webSocket_onerror(n) {
    logDebugError("Connection Error: " + n.data)
}
function onConnect() {
    $("#connectError").hide();
    $("#passwordError").hide();
    $("#connectButton").hide();
    connect($("#serverIPAddress").val()).then(function(n) {
        $("#connectDialog").modal("hide");
        connected(n)
    }, function(n) {
        $("#connectDialog").modal("show");
        n == "PasswordError" ? $("#passwordError").fadeIn() : $("#connectError").fadeIn();
        $("#connectButton").fadeIn()
    })
}
function connect(n) {
    return new Promise(function(t, i) {
        webSocketIsConnected() ? t(serverInfo) : (serverIPAddress = n.split(":")[0],
        getServerInfo().then(function(n) {
            $("#connectDialog").modal("hide");
            serverInfo = n;
            serverInfo.usepass ? loginWithPassword(serverPass).then(function() {
                openWebSocket();
                t(serverInfo)
            }, function() {
                i("PasswordError")
            }) : (serverPass = "",
            openWebSocket(),
            t(serverInfo))
        }, function() {
            i("ConnectError")
        }))
    }
    )
}
function getServerInfo() {
    return new Promise(function(n, t) {
        ajaxGetNoConnect({
            url: getServerUrl("ide?cmd=getinfo"),
            timeout: 5e3
        }).then(function(t) {
            var i = JSON.parse(t);
            typeof i.usepass == "undefined" && (i.usepass = !1);
            typeof i.devicename == "undefined" && (i.devicename = serverIPAddress);
            n(i)
        }, t)
    }
    )
}
function loginWithPassword(n) {
    return new Promise(function(t, i) {
        function r(n) {
            n.length > 0 ? ajaxGetNoConnect({
                url: getServerUrl("ide?cmd=login&pass=" + n),
                timeout: 5e3
            }).then(function(r) {
                var u = JSON.parse(r);
                u.status == "ok" ? (serverPass = n,
                t()) : i(u.status)
            }, i) : i()
        }
        if (typeof n == "undefined" || n == "")
            if ($("#passwordDialogOkButton").off("click").click(function() {
                $("#passwordDialogError").hide();
                var n = $("#passwordDialogPassword").val();
                n = btoa(n);
                r(n)
            }),
            $("#passwordDialogCancelButton").off("click").click(function() {
                $("#passwordDialogError").hide();
                i("PasswordCanceled")
            }),
            $("#passwordDialogPassword").val(""),
            $("#passwordDialog").is(":visible")) {
                $("#passwordDialog").on("hidden", function() {
                    $("#passwordDialog").off("hidden");
                    $("#passwordDialog").modal("show")
                });
                $("#passwordDialog").modal("hide")
            } else
                $("#passwordDialog").modal("show");
        else
            r(n)
    }
    )
}
function connected(n) {
    var i = n.appname, t;
    $("#ideTitle").append(" " + i);
    document.title = i;
    t = document.createElement("link");
    t.type = "image/x-icon";
    t.rel = "shortcut icon";
    t.href = isDroidScriptJunior() ? "resources/dsjicon.png" : "resources/dsicon.png";
    document.getElementsByTagName("head")[0].appendChild(t);
    isDroidScriptJunior() ? $("#ideTitleIcon").attr("src", "resources/droidscriptjunior.png") : $("#ideTitleIcon").attr("src", "resources/droidscript.png");
    $("#ideTitleIcon").show();
    refreshAppsList().then(function() {
        var i, t;
        populateSampleContents();
        chromeApp.isInitialised() ? (i = $("<webview id='docs' src='' width='100%' height='100%'><\/webview>"),
        i.appendTo(".docsWrapper"),
        chromeApp.setLocalStorageString("ip", serverIPAddress),
        typeof n.macaddress != "undefined" && chromeApp.setDeviceId(n.macaddress)) : (i = $("<iframe id='docs' src='' frameborder='0'><\/iframe>"),
        i.appendTo(".docsWrapper"));
        $("#docs").attr("src", getServerUrl(".edit/docs/Docs.htm"));
        t = n.lastprog;
        t != "null" && AppList.getApp(t) != null ? (logDebugMessage("Opening most recently edited app - '" + t + "'...."),
        openApp(AppList.getApp(t))) : $('#leftPanelTabs a[href="#appsTab"]').tab("show")
    })
}
function getServerUrl(n) {
    var t = "http://";
    return t = t + serverIPAddress,
    t = t + ":8088/",
    t + n
}
function getServerWSUrl(n) {
    var t = "ws://";
    return t = t + serverIPAddress,
    t = t + ":8088/",
    t + n
}
function onRequestError() {
    $("#errorDialog").modal("show")
}
function onUploadError() {
    $("#errorDialog").modal("show")
}
function ajaxGet(n) {
    return new Promise(function(t, i) {
        simulate ? sim_ajaxGet(simulate, n, t, i) : connect(serverIPAddress).then(function() {
            n.cache = !1;
            var r = $.ajax(n);
            r.done(function(n) {
                t(n)
            });
            r.fail(function() {
                i()
            })
        }, i)
    }
    )
}
function ajaxGetNoConnect(n) {
    return new Promise(function(t, i) {
        if (simulate)
            sim_ajaxGet(simulate, n, t, i);
        else {
            n.cache = !1;
            var r = $.ajax(n);
            r.done(function(n) {
                t(n)
            });
            r.fail(function() {
                i()
            })
        }
    }
    )
}
function refreshAssets() {
    populateImageAssets();
    populateSoundAssets();
    populateHtmlAssets();
    populateMiscAssets()
}
function populateImageAssets() {
    var n = AppList.getOpenApp().folder + "/Img";
    ajaxGet({
        url: getServerUrl("ide?cmd=list&dir=" + encodeURIComponent(n))
    }).then(function(t) {
        var i = sortList(JSON.parse(t).list);
        populateAssets(i, $("#imageAssetsList"), n, "resources/image.png");
        $("#imageAssetsList").find("img").each(function(t) {
            loadExternalImage(getServerUrl(n + "/") + i[t], $(this))
        })
    })
}
function populateSoundAssets() {
    var n = AppList.getOpenApp().folder + "/Snd";
    ajaxGet({
        url: getServerUrl("ide?cmd=list&dir=" + encodeURIComponent(n))
    }).then(function(t) {
        var i = sortList(JSON.parse(t).list);
        populateAssets(i, $("#soundAssetsList"), n, "resources/sound.png")
    })
}
function populateHtmlAssets() {
    var n = AppList.getOpenApp().folder + "/html";
    ajaxGet({
        url: getServerUrl("ide?cmd=list&dir=" + encodeURIComponent(n))
    }).then(function(t) {
        var i = sortList(JSON.parse(t).list);
        populateAssets(i, $("#htmlAssetsList"), n, "resources/html.png")
    })
}
function populateMiscAssets() {
    var n = AppList.getOpenApp().folder + "/misc";
    ajaxGet({
        url: getServerUrl("ide?cmd=list&dir=" + encodeURIComponent(n))
    }).then(function(t) {
        var i = sortList(JSON.parse(t).list);
        populateAssets(i, $("#miscAssetsList"), n, "resources/file.png")
    })
}
function populateAssets(n, t, i, r) {
    var u, e, f;
    for (t.empty(),
    u = 0; u < n.length; u++)
        n[u].indexOf(".nomedia") == -1 && (e = "",
        e += '<li>\n<div class="thumbnail">\n<div style="height: 64px; text-align: center; vertical-align: middle;">\n<img alt="" src="' + r + '" style="width: 64px; max-height: 64px"/>\n<\/div>\n<div class="caption">\n<div class="well thumbnailFilename">' + n[u] + '<\/div>\n<p class="thumbnailButtons">\n<a id="renameAssetButton" href="#" class="btn btn-mini btn-flat btn-noborder" data-toggle="tooltip" title="Rename">\n<i class="icon-edit"><\/i>\n<\/a>\n<a id="deleteAssetButton" href="#" class="btn btn-mini btn-flat btn-noborder" data-toggle="tooltip" title="Delete">\n<i class="icon-trash"><\/i>\n<\/a>\n<\/p>\n<\/div>\n<\/div>\n<\/li>\n',
        f = $(e),
        f.data("assetFile", n[u]),
        f.data("assetDir", i),
        t.append(f));
    updateTooltips()
}
function assetFileUploadChanged(n, t, i, r) {
    if ($("input[id=" + n + "]").val() != "") {
        $("#" + n).attr("name", AppList.getOpenApp().folder + i);
        var u = new FormData($("#" + t)[0]);
        $.ajax({
            url: getServerUrl("uploader"),
            data: u,
            processData: !1,
            contentType: !1,
            type: "POST"
        }).done(r).fail(function(n, t, i) {
            onUploadError(n, t, i)
        });
        $("input[id=" + n + "]").val("")
    }
}
function onSave() {
    save(AppList.getOpenApp().activeEditorFile).then(null, onRequestError)
}
function save(n) {
    return new Promise(function(t, i) {
        if (n.isOpen() && n.modified) {
            var r = AppList.getOpenApp();
            n.save(r.getEditorFilePath(n)).then(function() {
                for (var i = 0; i < r.editorFiles.length; ++i)
                    r.editorFiles[i].clearAnnotations();
                setModified(n, !1);
                t()
            }, i)
        } else
            t()
    }
    )
}
function saveAll() {
    return new Promise(function(n, t) {
        for (var r = [], i = 0; i < AppList.getOpenApp().editorFiles.length; ++i)
            r.push(save(AppList.getOpenApp().editorFiles[i]));
        Promise.all(r).then(n, t)
    }
    )
}
function onRun() {
    ajaxGet({
        url: getServerUrl("ide?cmd=stop")
    }).then(function() {
        return saveAll()
    }).then(function() {
        clearDebugLog();
        ajaxGet({
            url: getServerUrl("ide?cmd=run&prog=" + encodeURIComponent(AppList.getOpenApp().getName()))
        })
    }, function() {
        onRequestError()
    })
}
function onStop() {
    ajaxGet({
        url: getServerUrl("ide?cmd=stop")
    }).then(null, onRequestError)
}
function addSampleButton(n, t, i) {
    var u = '<div><a id=\'sampleButton\' class="btn btn-flat" style="width: 100%; padding: 0px"><p style="margin: 5px; text-align: left; font-size: 16px"><b>' + n + '<\/b><\/p><p style="margin: 5px; text-align: left;">' + t + "<\/p><\/a><\/div>"
      , r = $(u);
    r.data("title", n);
    r.data("type", i);
    $("#samplesContentList").append(r)
}
function populateSampleContents() {
    ajaxGet({
        url: getServerUrl("ide?cmd=getsamples")
    }).then(function(n) {
        for (var t, u = JSON.parse(n).samples, r = u.split(","), i = 0; i < r.length; ++i)
            t = r[i].split(":"),
            addSampleButton(t[0], t[1], t[2])
    })
}
function runSample() {
    var n = currentSample.split(" ").join("_");
    ajaxGet({
        url: getServerUrl("ide?cmd=sample&name=" + n)
    })
}
function onSampleFilter() {
    var n = $("#sampleFilter").val().trim(), t;
    n.length == 0 ? $("#samplesContentList").children("div").each(function() {
        $(this).show()
    }) : (n = n.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&"),
    t = new RegExp(n,"i"),
    $("#samplesContentList").children("div").each(function() {
        var n = !1;
        $(this).find("p").each(function() {
            n |= t.test($(this).text())
        });
        n ? $(this).show() : $(this).hide()
    }));
    scrollDebugLogToBottom()
}
function isDroidScript() {
    return serverInfo.appname === "DroidScript"
}
function isDroidScriptJunior() {
    return serverInfo.appname === "DroidScriptJunior"
}
function appendAppToAppsList(n) {
    var i = "", r, t;
    i = n.getType() == "dsj" ? "resources/droidscriptjunior_app.png" : "resources/droidscript_app.png";
    r = '<li style="position: relative;" class="app-thumbnail">\n<div id="openAppButton" class="thumbnail" style="border: 0px; box-shadow: none;">\n<div style="text-align: center; vertical-align: middle;"><img class="app-image" src="' + i + '">\n<\/div><div><p class="appFilename">' + n.getName() + '<\/p>\n<\/div><\/div>\n<div id="appButtons" style="opacity: 0;">\n<div style="position: absolute; top: 0px; margin: 5px 10px;">\n<a id="renameAppButton" class="btn btn-mini btn-flat btn-noborder" data-toggle="tooltip" title="Rename"><i class="icon-edit"><\/i><\/a>\n<\/div>\n<div style="position: absolute; top: 0px; right: 0px; margin: 5px 10px;">\n<a id="deleteAppButton" class="btn btn-mini btn-flat btn-noborder" data-toggle="tooltip" title="Delete"><i class="icon-trash"><\/i><\/a>\n<\/div>\n<\/div>\n<\/li>\n';
    t = $(r);
    t.data("appName", n.getName());
    t.hover(function() {
        $(this).find("img").animate({
            opacity: "1.0"
        }, "fast");
        $(this).find("div#appButtons").animate({
            opacity: "1.0"
        }, "fast")
    }, function() {
        $(this).find("img").animate({
            opacity: "0.7"
        }, "fast");
        $(this).find("div#appButtons").animate({
            opacity: "0.0"
        }, "fast")
    });
    $("#appsList").append(t);
    loadExternalImage(getServerUrl(n.getIconPath()), t.find(".app-image"))
}
function refreshAppsList() {
    return new Promise(function(n, t) {
        var i = AppList.getOpenApp();
        ajaxGet({
            url: getServerUrl("ide?cmd=list&dir=")
        }).then(function(t) {
            var o = JSON.parse(t).list, r, u, e, f;
            for (AppList.clear(),
            $("#appsList").empty(),
            r = "",
            isDroidScript() && (r = '<li class="app-thumbnail" id="newApp">\n<div class="thumbnail" style="border: 0px; box-shadow: none;">\n<div style="text-align: center; vertical-align: middle;"><img class="app-image" src="resources/droidscript_app_new_js.png">\n<\/div><div><p class="appFilename">New App...<\/p>\n<\/div><\/div>\n<\/li>\n',
            u = $(r),
            $("#appsList").append(u),
            r = '<li class="app-thumbnail" id="newHtmlApp">\n<div class="thumbnail" style="border: 0px; box-shadow: none;">\n<div style="text-align: center; vertical-align: middle;"><img class="app-image" src="resources/droidscript_app_new_html.png">\n<\/div><div><p class="appFilename">New Html App...<\/p>\n<\/div><\/div>\n<\/li>\n',
            u = $(r),
            $("#appsList").append(u)),
            isDroidScriptJunior() && (r = '<li class="app-thumbnail" id="newDSJApp">\n<div class="thumbnail" style="border: 0px; box-shadow: none;">\n<div style="text-align: center; vertical-align: middle;"><img class="app-image" src="resources/droidscriptjunior_app_new.png">\n<\/div><div><p class="appFilename">New App...<\/p>\n<\/div><\/div>\n<\/li>\n',
            u = $(r),
            $("#appsList").append(u)),
            e = [],
            f = 0; f < o.length; f++)
                e.push(getDroidScriptApp(o[f]));
            Promise.all(e).then(function(t) {
                for (var r = 0; r < t.length; ++r)
                    t[r] && (AppList.addApp(t[r]),
                    appendAppToAppsList(t[r]));
                i != null && (AppList.removeApp(i.getName()),
                AppList.addApp(i));
                n()
            }, onRequestError)
        }, t)
    }
    )
}
function sortAppList() {
    var i = $("#appsList #newApp"), r = $("#appsList #newHtmlApp"), u = $("#appsList #newDSJApp"), t, n;
    i.remove();
    r.remove();
    u.remove();
    t = $("#appsList li").get();
    t.sort(function(n, t) {
        var i = $(n).data("appName")
          , r = $(t).data("appName");
        return i.toLowerCase() < r.toLowerCase() ? -1 : i.toLowerCase() > r.toLowerCase() ? 1 : 0
    });
    n = $("#appsList");
    $.each(t, function(t, i) {
        n.append(i)
    });
    isDroidScript() ? (n.prepend(r),
    n.prepend(i)) : isDroidScriptJunior() && n.prepend(u)
}
function getDroidScriptApp(n) {
    return new Promise(function(t, i) {
        var r = null
          , u = n.split(".")
          , f = u.length == 1;
        f && n.charAt(0) != "~" ? ajaxGet({
            url: getServerUrl("ide?cmd=list&dir=" + encodeURIComponent(n))
        }).then(function(i) {
            var u = JSON.parse(i).list, o = u.indexOf(n + ".dsj"), e, f;
            if (o != -1 && (u = [u[o]]),
            u.indexOf(n + ".js") != -1 || u.indexOf(n + ".html") != -1 || u.indexOf(n + ".dsj") != -1)
                for (r = new DroidScriptApp(n),
                e = 0; e < u.length; ++e)
                    isSupportedFileType(u[e]) && (f = CreateEditorFile(u[e]),
                    r.editorFiles.push(f),
                    f.displayName.toUpperCase() == n.toUpperCase() ? (f.canDelete = !1,
                    r.activeEditorFile = f,
                    r.mainEditorFile = f) : f.canDelete = !0);
            t(r)
        }, i) : t(r)
    }
    )
}
function newApp(n) {
    n == "js" ? $("#newAppDialogTitle").text("New App") : n == "html" ? $("#newAppDialogTitle").text("New Html App") : n == "dsj" ? $("#newAppDialogTitle").text("New App") : logDebugMessage("Cannot create app, unknown app type: " + n);
    var t = function() {
        var t = $("#newAppDialogAppName").val(), i;
        containsReservedCharacters(t) ? $("#newAppError").fadeIn() : ($("#newAppDialog").modal("hide"),
        i = "ide?cmd=add&prog=" + encodeURIComponent(t) + "&type=" + n,
        ajaxGet({
            url: getServerUrl(i)
        }).then(function() {
            return getDroidScriptApp(t)
        }).then(function(n) {
            AppList.addApp(n);
            appendAppToAppsList(n);
            sortAppList();
            openApp(n)
        }, onRequestError))
    };
    $("#newAppDialogButton").off("click").click(t);
    $("#newAppDialog").modal("show")
}
function openApp(n) {
    loadEditorFile(n.mainEditorFile, n).then(function() {
        AppList.getOpenApp() != null && AppList.getOpenApp().close();
        AppList.setOpenApp(n);
        $("#editorTabs").empty();
        for (var t = 0; t < n.editorFiles.length; ++t)
            n.editorFiles[t] == n.mainEditorFile ? $("#editorTabs").prepend(createEditorFileTab(n.editorFiles[t])) : $("#editorTabs").append(createEditorFileTab(n.editorFiles[t]));
        n.activeEditorFile = n.mainEditorFile;
        $('ul[id="editorTabs"] a').on("shown", onEditorFileTabChanged);
        $('#editorTabs a[href="' + n.activeEditorFile.tabId + '"]').tab("show");
        $('#leftPanelTabs a[href="#editorTab"]').tab("show");
        refreshAssets();
        n.getName().substring(0, 4) == "SWS-" ? ($("#runBtn").prop("disabled", !0),
        $("#stopBtn").prop("disabled", !0)) : ($("#runBtn").prop("disabled", !1),
        $("#stopBtn").prop("disabled", !1));
        $("#editorTabs").tabdrop();
        codeEditor.resize();
        blocklyEditor.resize();
        chromeApp.onAppOpened(n.getName());
        chromeApp.getLocalAppChanges(n.getName(), function(t) {
            var i = "Restore unsaved changes to the following file(s)?<br>";
            for (var r in t.files)
                t.files.hasOwnProperty(r) && (i += "<strong>" + r + "<\/strong>",
                i += "<br>");
            $("#restoreDiscardDialogRestoreButton").off("click").click(function() {
                for (var i in t.files)
                    if (t.files.hasOwnProperty(i)) {
                        function r(n) {
                            n != null && loadEditorFile(n, t).then(function() {
                                var i = t.files[n.filename];
                                n.session.setValue(i);
                                setModified(n, !0)
                            })
                        }
                        r(n.getEditorFileForFilename(i))
                    }
            });
            $("#restoreDiscardDialogDiscardButton").off("click").click(function() {
                chromeApp.discardLocalAppChanges(n.getName())
            });
            $("#restoreDiscardDialogMessage").html(i);
            $("#restoreDiscardDialog").modal("show")
        })
    }, onRequestError)
}
function onEditorFileTabChanged(n) {
    var i = n.target.getAttribute("href")
      , t = AppList.getOpenApp();
    t.activeEditorFile = t.getEditorFileForTab(i);
    loadEditorFile(t.activeEditorFile, t).then(function() {
        codeEditor.hide();
        blocklyEditor.hide();
        var n = t.activeEditorFile.editor;
        n.show();
        n.setEditorFile(t.activeEditorFile)
    }, function() {
        if (n.relatedTarget != null) {
            var t = $('#editorTabs a[href="' + n.relatedTarget.getAttribute("href") + '"]');
            t.tab("show")
        }
        onRequestError()
    })
}
function loadEditorFile(n, t) {
    return new Promise(function(i, r) {
        n.isOpen() ? (console.log("loadEditorFile session already created"),
        i()) : (console.log("loadEditorFile creating session"),
        ajaxGet({
            url: getServerUrl(encodeURIComponent(t.folder) + "/" + encodeURIComponent(n.filename)),
            dataType: "text"
        }).then(function(t) {
            (t == null || t == "") && (t = n.getType() == "dsj" ? '<xml xmlns="http://www.w3.org/1999/xhtml"><\/xml>' : $("#phoneAppTemplate").text());
            n.setValue(t);
            console.log("session created");
            i()
        }, r))
    }
    )
}
function createEditorFileTab(n) {
    var i = "", t;
    return i = n.canDelete ? '<li style="position:relative"><a style="padding-right:25px" href="' + n.tabId + '" data-toggle="tab">' + n.filename + '<\/a><button class="close deleteFileBtn" data-toggle="tooltip" data-original-title="Delete"><i class="icon-trash"><\/i><\/button><\/li>' : '<li><a href="' + n.tabId + '" data-toggle="tab">' + n.filename + "<\/a><\/li>",
    t = $(i),
    t.data("editorFile", n),
    t
}
function newFile(n, t) {
    var i, r;
    if (n.trim().length == 0) {
        $("#newFileError").html("<b>Emtpy Filename.<\/b> Please enter a filename.");
        $("#newFileError").fadeIn();
        return
    }
    for (t.toLowerCase().localeCompare("text") == 0 ? n.toLowerCase().indexOf(".txt") == -1 && (n += ".txt") : t.toLowerCase().localeCompare("html") == 0 ? n.toLowerCase().indexOf(".htm") == -1 && (n += ".html") : t.toLowerCase().localeCompare("css") == 0 ? n.toLowerCase().indexOf(".css") == -1 && (n += ".css") : n.toLowerCase().indexOf(".js") == -1 && (n += ".js"),
    i = 0; i < AppList.getOpenApp().editorFiles.length; ++i)
        if (AppList.getOpenApp().editorFiles[i].filename.toLowerCase() == n.toLowerCase()) {
            $("#newFileError").html("<b>Cannot Create File.<\/b> A file with the name '" + n + "' already exists.");
            $("#newFileError").fadeIn();
            return
        }
    r = getDefaultFileContent(n);
    createFile(AppList.getOpenApp().folder + "/" + n, r).then(function() {
        var t = CreateEditorFile(n), i;
        t.canDelete = !0;
        AppList.getOpenApp().editorFiles.push(t);
        $("#editorTabs").append(createEditorFileTab(t));
        $("#editorTabs").data("tabdrop").layout();
        AppList.getOpenApp().activeEditorFile = t;
        i = $('#editorTabs a[href="' + AppList.getOpenApp().activeEditorFile.tabId + '"]');
        i.on("shown", onEditorFileTabChanged);
        i.tab("show");
        $("#newFileDialog").modal("hide")
    }, function() {
        logDebugMessage("Failed to create file " + n + ". Is DroidScript running and Wi-Fi enabled?")
    })
}
function createFile(n, t) {
    return new Promise(function(i, r) {
        var u = getServerUrl("uploader");
        connect(serverIPAddress).then(function() {
            var e = new FormData, o = new Blob([t],{
                type: "text/plain"
            }), f;
            e.append(".", o, n);
            f = $.ajax({
                url: u,
                data: e,
                cache: !1,
                contentType: !1,
                processData: !1,
                type: "POST"
            });
            f.fail(function(i, u) {
                console.log("createFile(" + n + ", " + t + ") failed: " + u);
                r()
            });
            f.done(function() {
                i()
            })
        }, r)
    }
    )
}
function setModified(n, t) {
    if (n.setModified(t),
    t)
        chromeApp.onFileModified(n.filename, n.getValue());
    else
        chromeApp.onFileSaved(n.filename);
    var i = n.modified ? "*" + n.filename : n.filename;
    $('#editorTabs a[href="' + n.tabId + '"]').text(i);
    $("#editorTabs").data("tabdrop").layout()
}
function onCollapseAll() {
    var n = AppList.getOpenApp().activeEditorFile.getEditor();
    n != null && n.collapseAll()
}
function onExpandAll() {
    var n = AppList.getOpenApp().activeEditorFile.getEditor();
    n != null && n.expandAll()
}
function containsReservedCharacters(n) {
    return /[|\\?*<\":>\[\]\/']+/.test(n)
}
function loadExternalImage(n, t) {
    var i = new XMLHttpRequest;
    i.open("GET", n, !0);
    i.responseType = "blob";
    i.onreadystatechange = function() {
        this.readyState == 4 && this.status == 200 && t.attr("src", window.URL.createObjectURL(this.response))
    }
    ;
    i.send()
}
function sortList(n) {
    return n.sort(function(n, t) {
        return n.toLowerCase().localeCompare(t.toLowerCase())
    }),
    n
}
function stringToArrayBuffer(n) {
    for (var i = new ArrayBuffer(n.length * 2), r = new Uint8Array(i), t = 0, u = n.length; t < u; t++)
        r[t] = n.charCodeAt(t);
    return i
}
function arrayBufferToString(n) {
    return String.fromCharCode.apply(null, new Uint8Array(n))
}
function DroidScriptApp(n) {
    this.folder = n;
    this.editorFiles = [];
    this.activeEditorFile = null;
    this.mainEditorFile = null
}
var g_ignoreFuncs, androidScriptCompleter, g_objFunctionCache, uniqueTabIdCounter, supportedFileExtensions, webSocketKeepAliveTimer;
_dbg = !0;
_map = [];
_scripts = [];
_cbMap = [];
_cbId = 0;
_docs = !1;
_busy = !1;
_btl = null;
_lvw = null;
_ldg = null;
_ynd = null;
_nxt = null;
_inf = null;
_rec = null;
_ioi = null;
_sms = null;
_eml = null;
_smw = null;
_crp = null;
_spr = null;
ChromeApp.prototype.isInitialised = function() {
    return this.initialised
}
;
ChromeApp.prototype.init = function() {
    this.initialised = !0;
    localThis = this;
    chrome.runtime.getPlatformInfo(function(n) {
        n.os == "win" && localThis._startDiscovery()
    })
}
;
ChromeApp.prototype.getPlatformOS = function(n) {
    chrome.runtime.getPlatformInfo(function(t) {
        n(t.os)
    })
}
;
ChromeApp.prototype.setDeviceId = function(n) {
    this.deviceId = n
}
;
ChromeApp.prototype._startDiscovery = function() {
    this.broadcastSocket = new UDPSocket;
    var n = this.broadcastSocket;
    this.broadcastSocket.open(function() {
        n.setOnReceive(function(n) {
            var t = null, r, i, u;
            try {
                t = JSON.parse(arrayBufferToString(n.data));
                console.log(t)
            } catch (f) {
                t = null
            }
            t != null && (console.log(t),
            r = !1,
            $("#connectServers").children("a").each(function() {
                r |= $(this).data("ipAddress") == n.remoteAddress
            }),
            r || (i = '<a id=\'server\' class="btn btn-flat" style="width: 100%; padding: 0px">',
            t.usepass && (i += '<img src="resources/lock.png" style="float: right;margin: 3px"/>'),
            i += '<p style="margin: 3px 5px 0px 5px; text-align: left; font-size: 14px"><b>' + t.appname + " (" + t.devicename + ')<\/b><\/p><p style="margin: 0px 5px 3px 5px; text-align: left; font-size: 12px">' + n.remoteAddress + "<\/p><\/a>",
            u = $(i),
            u.data("ipAddress", n.remoteAddress),
            $("#connectServers").append(u)))
        });
        n.sendDiscoverDSSeverRequest();
        $("#connectServerSection").show()
    })
}
;
ChromeApp.prototype.getLocalStorageString = function(n, t) {
    this.initialised && chrome.storage.local.get(n, function(i) {
        i != null && typeof i[n] == "string" && t(i[n])
    })
}
;
ChromeApp.prototype.setLocalStorageString = function(n, t) {
    if (this.initialised) {
        var i = {};
        i[n] = t;
        chrome.storage.local.set(i)
    }
}
;
ChromeApp.prototype.onAppOpened = function(n) {
    if (this.initialised) {
        var t = this.deviceId;
        chrome.runtime.getBackgroundPage(function(i) {
            i.onAppOpened(n, t)
        })
    }
}
;
ChromeApp.prototype.onFileModified = function(n, t) {
    this.initialised && chrome.runtime.getBackgroundPage(function(i) {
        i.onFileModified(n, t)
    })
}
;
ChromeApp.prototype.onFileSaved = function(n) {
    this.initialised && chrome.runtime.getBackgroundPage(function(t) {
        t.onFileSaved(n)
    })
}
;
ChromeApp.prototype.getLocalAppChanges = function(n, t) {
    if (this.initialised) {
        var i = this.deviceId;
        chrome.runtime.getBackgroundPage(function(r) {
            r.getLocalAppChanges(n, i, t)
        })
    }
}
;
ChromeApp.prototype.discardLocalAppChanges = function(n) {
    if (this.initialised) {
        var t = this.deviceId;
        chrome.runtime.getBackgroundPage(function(i) {
            i.forgetApp(n, t)
        })
    }
}
;
ChromeApp.prototype.zoom = function(n) {
    $("#pageBody").css("zoom", n);
    var t = document.getElementById("homeView");
    t != null && t.setZoom(n);
    t = document.getElementById("docs");
    t != null && t.setZoom(n)
}
;
UDPSocket.prototype.open = function(n, t) {
    var i = this;
    chrome.sockets.udp.create({}, function(r) {
        i.socketId = r.socketId;
        chrome.runtime.getBackgroundPage(function(n) {
            n.setBroadcastSocketId(i.socketId)
        });
        chrome.sockets.udp.bind(i.socketId, "0.0.0.0", 19800, function(i) {
            if (i < 0) {
                console.log("Error binding socket.");
                t != null && t(i);
                return
            }
            n()
        })
    })
}
;
UDPSocket.prototype.close = function() {
    this.socketId != -1 && (chrome.sockets.udp.close(this.socketId),
    this.socketId = -1,
    chrome.runtime.getBackgroundPage(function(n) {
        n.setBroadcastSocketId(-1)
    }))
}
;
UDPSocket.prototype.setOnReceive = function(n) {
    chrome.sockets.udp.onReceive.addListener(n)
}
;
UDPSocket.prototype.sendDiscoverDSSeverRequest = function() {
    this.sendBroadcastMessage("DISCOVER_DSSERVER_REQUEST")
}
;
UDPSocket.prototype.sendBroadcastMessage = function(n) {
    var t = this;
    this.getBroadcastAddresses(function(i) {
        var u, r;
        console.log("BroadcastAddresses: " + i);
        try {
            for (u = stringToArrayBuffer(n),
            r = 0; r < i.length; ++r)
                chrome.sockets.udp.send(t.socketId, u, i[r], 19800, function(n) {
                    console.log(n)
                })
        } catch (f) {
            console.log("sendBroadcastMessage: " + f)
        }
    })
}
;
UDPSocket.prototype.getBroadcastAddresses = function(n) {
    this.getLocalIPAddresses(function(t) {
        var i, r, u;
        for (console.log(t),
        i = [],
        r = 0; r < t.length; ++r)
            u = t[r].split("."),
            u.length == 4 && (u[3] = 255,
            broadcastIp = u.join("."),
            i.indexOf(broadcastIp) == -1 && i.push(broadcastIp));
        i.length > 0 && n(i)
    })
}
;
UDPSocket.prototype.getLocalIPAddresses = function(n) {
    var t = [];
    chrome.system.network.getNetworkInterfaces(function(i) {
        for (var u, r = 0; r < i.length; ++r)
            u = i[r].address.split("."),
            u.length == 4 && t.push(i[r].address);
        n(t)
    })
}
;
var Autocomplete = require("ace/autocomplete").Autocomplete
  , Range = require("ace/range").Range
  , Document = require("ace/document").Document
  , EditSession = require("ace/edit_session").EditSession
  , UndoManager = require("ace/undomanager").UndoManager;
AceEditor.prototype.init = function(n, t) {
    if (!this.initialised) {
        if (this.domElement = n,
        this.editor = ace.edit(n),
        this.editor.setTheme("ace/theme/textmate"),
        this.editor.getSession().setMode("ace/mode/javascript"),
        this.editor.setFontSize("14px"),
        this.editor.setBehavioursEnabled(!1),
        this.editor.setOptions({
            enableBasicAutocompletion: !0
        }),
        this.editor.completers = [androidScriptCompleter],
        t)
            this.editor.setReadOnly(!0),
            this.editor.renderer.setShowGutter(!1),
            this.editor.setHighlightActiveLine(!1),
            this.editor.getSession().setUseWorker(!1);
        else {
            this.$onTokensChanged = this.onTokensChanged.bind(this);
            this.$onDocumentChanged = this.onDocumentChanged.bind(this);
            var i = this;
            this.editor.on("changeSession", function(n) {
                if (n.session) {
                    n.session.on("tokenizerUpdate", i.$onTokensChanged);
                    n.session.on("change", i.$onDocumentChanged);
                    var t = {
                        first: 0,
                        last: n.session.getLength()
                    };
                    i.onTokensChanged({
                        data: t
                    })
                }
                n.oldSession && (n.oldSession.removeEventListener("tokenizerUpdate", i.$onTokensChanged),
                n.oldSession.removeEventListener("change", i.$onDocumentChanged))
            })
        }
        this.initialised = !0
    }
}
;
AceEditor.prototype.setEditorFile = function(n) {
    this.editor.setSession(n.session)
}
;
AceEditor.prototype.setValue = function(n) {
    this.editor.setValue(n)
}
;
AceEditor.prototype.setFocus = function() {
    this.editor.focus()
}
;
AceEditor.prototype.setReadOnly = function(n) {
    this.editor.setReadOnly(n);
    this.editor.renderer.setShowGutter(!n);
    this.editor.setHighlightActiveLine(!n);
    n && this.editor.getSession().setUseWorker(!1)
}
;
AceEditor.prototype.scrollToLine = function(n) {
    this.editor.scrollToLine(n, !0, !0)
}
;
AceEditor.prototype.moveCursorTo = function(n, t) {
    this.editor.moveCursorTo(n, t)
}
;
AceEditor.prototype.resize = function() {
    this.editor.resize()
}
;
AceEditor.prototype.show = function() {
    $(this.domElement).show();
    this.functionDropdown != null && this.functionDropdown.show()
}
;
AceEditor.prototype.hide = function() {
    $(this.domElement).hide();
    this.functionDropdown != null && this.functionDropdown.hide()
}
;
AceEditor.prototype.addChangeListener = function(n) {
    this.onChangeFunc = n
}
;
AceEditor.prototype.collapseAll = function() {
    var n = this.editor.getSession();
    n.foldAll(0, n.getLength(), 0)
}
;
AceEditor.prototype.expandAll = function() {
    var n = this.editor.getSession()
      , t = new Range(0,0,n.getLength(),0);
    n.unfold(t, !1)
}
;
AceEditor.prototype.onDocumentChanged = function(n) {
    if (this.onChangeFunc != null && this.onChangeFunc(),
    n.data.action == "insert") {
        var t = this;
        setTimeout(function() {
            t.showAutocompletePopup()
        }, 500)
    }
}
;
g_types = {
    App: "App",
    Layout: "Lay",
    Image: "Img",
    Button: "Btn",
    Toggle: "Tgl",
    CheckBox: "Chk",
    Spinner: "Spn",
    SeekBar: " Skb",
    Text: "Txt",
    TextEdit: "Txe",
    List: "Lst",
    WebView: "Web",
    Scroller: "Scr",
    CameraView: "Cam",
    VideoView: "Vid",
    YesNoDialog: "Ynd",
    ListDialog: "Ldg",
    ListView: "Lvw",
    BluetoothList: "Btl",
    AudioRecorder: "Rec",
    IOIO: "IOIO",
    SMS: "SMS",
    Email: "EMAIL",
    SmartWatch: "SMW",
    Crypt: "Crp",
    SpeechRec: "Spr",
    Dialog: "Dlg",
    MediaPlayer: "Aud",
    Sensor: "Sns",
    Locator: "Loc",
    NetClient: "Net",
    NxtRemote: "Nxt",
    WebServer: "Wbs",
    USBSerial: "Usb",
    SysProc: "Sys",
    Service: "Svc",
    Synth: "Syn",
    BluetoothSerial: "Bts",
    ZipUtil: "Zip",
    Downloader: "Dwn",
    MediaStore: "Med",
    PlayStore: "Ply",
    Notification: "Not",
    File: "Fil",
    Tabs: "_Tabs",
    GLView: "GLV"
};
g_ignoreFuncs = {
    App: ["StartService", "StopService", "Try", "Odroid", "_Extract", "CreateIOIO", "CreateSmartWatch", "CreateService", "StartDebugServer"]
};
androidScriptCompleter = {
    getCompletions: function(n, t, i, r, u) {
        var o = t.getTokenAt(i.row, i.column), e, f, h, s;
        (o.type == "punctuation.operator" && o.value == "." || o.type == "identifier") && (e = t.getTokens(i.row),
        f = e.indexOf(o),
        o.type == "identifier" && f > 0 && f < e.length && (f = f - 1,
        (e[f].type != "punctuation.operator" || e[f].value != ".") && (f = -1)),
        f > 0 && f < e.length && (f = f - 1,
        e[f].type == "identifier" && (h = getObjType(e[f].value, t.getValue()),
        h != null && (s = getObjFunctions(h),
        s.length > 0 && (r != "" && (s = s.filter(function(n) {
            return n.lastIndexOf(r, 0) == 0
        })),
        u(null, s.map(function(n) {
            return {
                name: n,
                value: n,
                score: 1,
                meta: "function"
            }
        })))))));
        u(null, [])
    }
};
AceEditor.prototype.showAutocompletePopup = function() {
    if (!this.editor.completer || !this.editor.completer.activated) {
        var t = this.editor.getCursorPosition()
          , n = this.editor.getSession().getTokenAt(t.row, t.column);
        n != null && n.type == "punctuation.operator" && n.value == "." && Autocomplete.startCommand.exec(this.editor)
    }
}
;
g_objFunctionCache = {};
AceEditor.prototype.onTokensChanged = function() {
    for (var t, n, e, o, r, f, s, i = [], h = this.editor.getSession(), c = h.getLength(), u = 0; u <= c; ++u)
        for (t = h.getTokens(u),
        n = 0; n < t.length; ++n)
            if (t[n].type == "storage.type" && t[n].value == "function") {
                t.length > n + 2 && (e = t[n + 2],
                e.type == "entity.name.function" && i.push({
                    name: e.value,
                    line: u + 1
                }));
                break
            }
    for (i.sort(function(n, t) {
        return n.name.toLowerCase() < t.name.toLowerCase() ? -1 : n.name.toLowerCase() > t.name.toLowerCase() ? 1 : 0
    }),
    o = "",
    r = 0; r < i.length; ++r)
        f = '<li id="' + i[r].line + '">',
        f += '<a href="#">' + i[r].name + "<\/a>",
        f += "<\/li>\n",
        o += f;
    $("#functionJumpList").html(o);
    s = this;
    $("ul[id*=functionJumpList] li").click(function() {
        s.editor.gotoLine($(this).attr("id"), 0, !0);
        s.editor.focus()
    })
}
;

BlocklyEditor.prototype.init = function(n, t) {
    this.initialised || (this.domElement = n,
    this.readOnly = t,
    console.log("Blockly init"),
    this.workspace = Blockly.inject(n, {
        toolbox: document.getElementById("toolbox"),
        readOnly: t,
        scrollbars: !0,
        media: "blockly/media/",
        comments: !1,
        disable: !1,
        zoom: {
            enabled: !0
        }
    }),
    Blockly.JavaScript.finish = function(n) {
        var r = Blockly.JavaScript.definitions_.variables
          , t = [];
        for (var i in Blockly.JavaScript.definitions_)
            i != "variables" && t.push(Blockly.JavaScript.definitions_[i]);
        return 'app.LoadScript("/sdcard/DroidScriptJr/DSJExtras.js");\n\n' + r + "\n\n" + n + "\n" + t.join("\n\n")
    }
    ,
    this.initialised = !0)
}
;
BlocklyEditor.prototype.setEditorFile = function(n) {
    function u() {
        t.workspace.removeChangeListener(r);
        t.onChangeFunc != null && t.addChangeListener(t.onChangeFunc)
    }
    var i, t, r;
    this.onChangeBindData != null && (this.workspace.removeChangeListener(this.onChangeBindData),
    console.log("removeChangeListener"));
    i = decodeURIComponent(n.workspace);
    t = this;
    r = this.workspace.addChangeListener(u);
    this.loadWorkspace(i)
}
;
BlocklyEditor.prototype.loadWorkspace = function(n) {
    try {
        this.workspace.clear();
        var t = Blockly.Xml.textToDom(n);
        Blockly.Xml.domToWorkspace(this.workspace, t)
    } catch (i) {
        console.log("BlocklyEditor.loadWorkspace Error:");
        console.log(i)
    }
}
;
BlocklyEditor.prototype.getWorkspace = function() {
    try {
        var n = Blockly.Xml.workspaceToDom(this.workspace);
        return Blockly.Xml.domToPrettyText(n)
    } catch (t) {
        console.log("BlocklyEditor.getWorkspace Error:");
        console.log(t)
    }
    return null
}
;
BlocklyEditor.prototype.getJavaScript = function() {
    try {
        Blockly.JavaScript.INFINITE_LOOP_TRAP = null;
        return Blockly.JavaScript.workspaceToCode(this.workspace)
    } catch (n) {
        console.log("BlocklyEditor.getJavaScript Error:");
        console.log(n)
    }
    return null
}
;
BlocklyEditor.prototype.setFocus = function() {}
;
BlocklyEditor.prototype.show = function() {
    $(this.domElement).show();
    this.readOnly || ($(".blocklyToolboxDiv").show(),
    $("#jsButton").show())
}
;
BlocklyEditor.prototype.hide = function() {
    Blockly.hideChaff();
    $(this.domElement).hide();
    this.readOnly || ($(".blocklyToolboxDiv").hide(),
    $("#jsButton").hide())
}
;
BlocklyEditor.prototype.resize = function() {
    Blockly.svgResize(this.workspace)
}
;
BlocklyEditor.prototype.addChangeListener = function(n) {
    console.log("addChangeListener");
    this.onChangeFunc = n;
    this.onChangeBindData = this.workspace.addChangeListener(n)
}
;
BlocklyEditor.prototype.collapseAll = function() {
    for (var n, i = this.workspace.getTopBlocks(!1), r = 0, t = 0; t < i.length; t++)
        for (n = i[t]; n; )
            setTimeout(n.setCollapsed.bind(n, !0), r),
            n = n.getNextBlock(),
            r += 10
}
;
BlocklyEditor.prototype.expandAll = function() {
    for (var n, i = this.workspace.getTopBlocks(!1), r = 0, t = 0; t < i.length; t++)
        for (n = i[t]; n; )
            setTimeout(n.setCollapsed.bind(n, !1), r),
            n = n.getNextBlock(),
            r += 10
}
;
uniqueTabIdCounter = 1;
DroidScriptEditorFile.prototype.setModified = function(n) {
    this.modified = n
}
;
DroidScriptEditorFile.prototype.getType = function() {
    return this.filename.split(".")[1]
}
;
DroidScriptEditorFile.prototype.getEditor = function() {
    return this.editor
}
;
supportedFileExtensions = ["js", "htm", "html", "css", "txt", "json", "xml", "dsj"];
var codeEditor = null, sampleEditor = null, blocklyEditor = null, webSocket, serverIPAddress = "", currentSample = "", simulate = null, chromeApp = new ChromeApp, serverInfo = null, serverPass = "", AppList = {
    openAppName: "",
    appMap: {},
    getOpenApp: function() {
        return this.openAppName == "" ? null : this.appMap[this.openAppName]
    },
    setOpenApp: function(n) {
        n == null && (this.openAppName = "");
        this.openAppName = n.getName()
    },
    getApp: function(n) {
        return this.appMap[n]
    },
    removeApp: function(n) {
        delete this.appMap[n]
    },
    addApp: function(n) {
        this.appMap[n.getName()] = n
    },
    clear: function() {
        this.appMap = {}
    }
}, busyStack = 0, busySpinnerOnTimer = null, busySpinnerOffTimer = null;
document.addEventListener("DOMContentLoaded", function() {
    console.log("DOMContentLoaded");
    document.body.addEventListener("resize", onEditorResize);
    document.querySelector("#newBtn").addEventListener("click", function() {
        $("#newFileError").hide();
        $("#newFileDialog").modal("show")
    });
    document.querySelector("#saveBtn").addEventListener("click", onSave);
    document.querySelector("#runBtn").addEventListener("click", onRun);
    document.querySelector("#stopBtn").addEventListener("click", onStop);
    document.querySelector("#collapseAllBtn").addEventListener("click", onCollapseAll);
    document.querySelector("#expandAllBtn").addEventListener("click", onExpandAll);
    document.querySelector("#expBtn").addEventListener("click", onExpand);
    document.querySelector("#jsBtn").addEventListener("click", onToggleJS);
    document.querySelector("#sampleJSBtn").addEventListener("click", onToggleSampleJS);
    document.querySelector("#imgUploadBtn").addEventListener("click", function() {
        $("input[id=imageUploadFile]").click()
    });
    document.querySelector("#sndUploadBtn").addEventListener("click", function() {
        $("input[id=soundUploadFile]").click()
    });
    document.querySelector("#htmlUploadBtn").addEventListener("click", function() {
        $("input[id=htmlUploadFile]").click()
    });
    document.querySelector("#miscUploadBtn").addEventListener("click", function() {
        $("input[id=miscUploadFile]").click()
    });
    document.querySelector("#reloadHomeBtn").addEventListener("click", loadHomePage);
    document.querySelector("#sampleBackBtn").addEventListener("click", function() {
        $("#sampleCodeView").hide();
        $("#sampleContentView").show()
    });
    document.querySelector("#sampleRunBtn").addEventListener("click", runSample);
    document.querySelector("#sampleStopBtn").addEventListener("click", onStop);
    document.querySelector("#sampleFilterClearBtn").addEventListener("click", function() {
        $("#sampleFilter").val("")
    });
    document.querySelector("#debugClearBtn").addEventListener("click", clearDebugLog);
    document.querySelector("#connectButton").addEventListener("click", onConnect);
    document.querySelector("#connectRefreshServerButton").addEventListener("click", function() {
        chromeApp.broadcastSocket != null && ($("#connectServers").empty(),
        chromeApp.broadcastSocket.sendDiscoverDSSeverRequest())
    });
    document.querySelector("#newFileDialogButton").addEventListener("click", function() {
        newFile($("#fileName").val(), $("#fileTypeChoice").html())
    });
    document.querySelector("#sampleFilter").addEventListener("change", onSampleFilter);
    document.querySelector("#sampleFilter").addEventListener("keypress", onSampleFilter);
    document.querySelector("#sampleFilter").addEventListener("paste", onSampleFilter);
    document.querySelector("#sampleFilter").addEventListener("input", onSampleFilter);
    document.querySelector("#sampleFilterClearBtn").addEventListener("click", function() {
        $("#sampleFilter").val("");
        onSampleFilter()
    });
    $("#sampleFilterForm").submit(function() {
        return !1
    });
    document.querySelector("#debugFilter").addEventListener("change", onDebugFilter);
    document.querySelector("#debugFilter").addEventListener("keypress", onDebugFilter);
    document.querySelector("#debugFilter").addEventListener("paste", onDebugFilter);
    document.querySelector("#debugFilter").addEventListener("input", onDebugFilter);
    document.querySelector("#debugFilterClearBtn").addEventListener("click", function() {
        $("#debugFilter").val("");
        onDebugFilter()
    });
    $("#debugFilterForm").submit(function() {
        return !1
    });
    $(".modal-with-form").on("shown", function() {
        $(this).find(".focus-input").focus()
    });
    $(".modal-form").submit(function(n) {
        n.preventDefault()
    });
    $('a[data-toggle="tab"]').on("show", function(n) {
        var t;
        n.target;
        n.relatedTarget;
        n.relatedTarget != null && n.relatedTarget.hash == "#editorTab" ? (t = AppList.getOpenApp(),
        t != null && t.activeEditorFile != null && t.activeEditorFile.editor.hide()) : n.target != null && n.target.hash == "#editorTab" && (t = AppList.getOpenApp(),
        t != null && t.activeEditorFile != null && t.activeEditorFile.editor.show())
    })
});
$(document).ready(function() {
    var r, n, i, t;
    console.log("ready");
    location.protocol == "chrome-extension:" && navigator.appVersion.indexOf("CrOS") != -1 && ($("#topNavBar").hide(),
    $("#pageContentWrapper").css("top", 0));
    $("#topNavBar").is(":visible") && (r = $("#topNavBar").outerHeight(!0),
    $("#pageContentWrapper").css("top", r));
    onEditorResize();
    n = $("#rightPanelTabs").outerHeight(!0);
    $(".homeWrapper").css("top", n);
    $(".samplesWrapper").css("top", n);
    $(".docsWrapper").css("top", n);
    $(".debugWrapper").css("top", n);
    updateTooltips();
    $(document).ajaxStart(function() {
        setBusy(!0)
    }).ajaxStop(function() {
        setBusy(!1)
    });
    var f = document.getElementById("busySpinner")
      , e = new Spinner({
        lines: 11,
        length: 20,
        width: 9,
        radius: 30,
        corners: 1,
        rotate: 0,
        direction: 1,
        color: "#000",
        speed: 1,
        trail: 60,
        shadow: !0,
        hwaccel: !0,
        className: "spinner",
        zIndex: 2e9,
        top: "auto",
        left: "auto"
    }).spin(f);
    if (initIDE(),
    location.protocol == "http:")
        if (/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(location.hostname)) {
            function u(n) {
                if (n == 5) {
                    onRequestError();
                    return
                }
                connect(location.hostname).then(function(n) {
                    connected(n)
                }, function(t) {
                    t == "PasswordError" ? ($("#passwordDialogError").show(),
                    u(++n)) : onRequestError()
                })
            }
            $("#passwordDialogCancelButton").hide();
            u(0)
        } else
            $("#connectDialog").modal("show");
    else
        location.protocol == "file:" ? location.href.toLowerCase().indexOf("smartscript") < 0 ? $("#connectDialog").modal("show") : (simulate = "SmartScript",
        connect("file")) : location.protocol == "chrome-extension:" ? (chromeApp.init(),
        chromeApp.getLocalStorageString("zoom", function(n) {
            chromeApp.zoom(parseFloat(n))
        }),
        chromeApp.getLocalStorageString("ip", function(n) {
            $("#serverIPAddress").val(n)
        }),
        $("#connectDialog").modal("show")) : console.log("Unable to determine where IDE is running from: " + document.URL);
    $("#newAppDialog").on("hidden", function() {
        $("#newAppError").hide()
    });
    $("#renameDialog").on("hidden", function() {
        $("#renameError").hide()
    });
    chromeApp.isInitialised() ? (t = $("<webview id='homeView' src=''><\/webview>"),
    t.appendTo(".homeWrapper"),
    i = document.getElementById("homeView"),
    i.addEventListener("loadstop", function() {
        clearTimeout(homePageErrorTimeout);
        $("#homeView").css("width", "100%");
        $("#homeView").css("height", "100%");
        $("#homeErrorPage").hide();
        window.addEventListener("message", onReceiveMessage);
        i.addEventListener("newwindow", function(n) {
            n.preventDefault();
            window.open(event.targetUrl)
        });
        i.contentWindow.postMessage({
            command: "handshake"
        }, "*")
    })) : (t = $("<iframe id='homeView' src='' frameborder='0'><\/iframe>"),
    t.appendTo(".homeWrapper"),
    window.addEventListener("message", onReceiveMessage));
    homePageErrorTimeout = setTimeout(function() {
        $("#homeErrorPage").show()
    }, 5e3);
    loadHomePage()
});
document.addEventListener("keydown", function(n) {
    var i = navigator.platform.match("Mac") ? n.metaKey : n.ctrlKey, t;
    n.keyCode == 83 && i ? (n.preventDefault(),
    onSave()) : n.keyCode == 78 && i ? (n.preventDefault(),
    onSave()) : n.keyCode == 82 && n.altKey ? (n.preventDefault(),
    onRun()) : n.keyCode == 83 && n.altKey ? (n.preventDefault(),
    onStop()) : n.keyCode == 116 || n.keyCode == 82 && i ? $("#appsTab").is(":visible") && (n.preventDefault(),
    refreshAppsList()) : n.keyCode == 187 && i ? chromeApp.isInitialised() && (n.preventDefault(),
    t = parseFloat($("#pageBody").css("zoom")),
    t = parseFloat(t.toFixed(1)),
    t += .1,
    chromeApp.zoom(t),
    chromeApp.setLocalStorageString("zoom", t.toFixed(1))) : n.keyCode == 189 && i && chromeApp.isInitialised() && (n.preventDefault(),
    t = parseFloat($("#pageBody").css("zoom")),
    t = parseFloat(t.toFixed(1)),
    t -= .1,
    t < .1 && (t = .1),
    chromeApp.zoom(t),
    chromeApp.setLocalStorageString("zoom", t.toFixed(1)))
}, !1);
window.onbeforeunload = function() {
    return "Any unsaved changes will be lost."
}
;
$(document).on("click", "#server", function() {
    var n = $(this).data("ipAddress");
    $("#serverIPAddress").val(n)
});
$(".immediate-form").on("submit", function() {
    var n = $("#immediate-code").val();
    return n.trim() != "" && ajaxGet({
        url: getServerUrl("ide?cmd=exec&code=" + encodeURIComponent(n))
    }),
    !1
});
webSocketKeepAliveTimer = null;
$(document).on("click", "#deleteAssetButton", function() {
    $(".tooltip").hide();
    var n = $(this).closest("li")
      , t = n.data("assetFile")
      , i = n.data("assetDir");
    typeof t != "undefined" && typeof i != "undefined" && ($("#okCancelDialogOkButton").off("click").click(function() {
        ajaxGet({
            url: getServerUrl("ide?cmd=delete&file=" + encodeURIComponent(i + "/" + t))
        }).then(function() {
            n.remove()
        })
    }),
    $("#okCancelDialogHeader").text("Delete Asset"),
    $("#okCancelDialogMessage").text("Are you sure you want to delete '" + t + "'?"),
    $("#okCancelDialog").modal("show"))
});
$(document).on("click", "#renameAssetButton", function() {
    var n = $(this).closest("li"), t = n.data("assetFile"), i = n.data("assetDir"), r;
    typeof t != "undefined" && typeof i != "undefined" && ($("#renameDialogName").val(t),
    r = function() {
        if ($("#renameDialogName").val() != "")
            if (containsReservedCharacters($("#renameDialogName").val()))
                $("#renameError").fadeIn();
            else {
                var r = i + "/" + t
                  , u = i + "/" + $("#renameDialogName").val();
                $("#renameDialog").modal("hide");
                ajaxGet({
                    url: getServerUrl("ide?cmd=rename&file=" + encodeURIComponent(r) + "&newname=" + encodeURIComponent(u))
                }).then(function() {
                    n.find("div.thumbnailFilename").text($("#renameDialogName").val());
                    n.data("assetFile", $("#renameDialogName").val());
                    var t = n.closest("ul").find("li");
                    t.sort(function(n, t) {
                        var i = $(n).data("assetFile")
                          , r = $(t).data("assetFile");
                        return i.toLowerCase() < r.toLowerCase() ? -1 : i.toLowerCase() > r.toLowerCase() ? 1 : 0
                    });
                    $.each(t, function(n, t) {
                        assetList.append(t)
                    })
                })
            }
    }
    ,
    $("#renameDialogButton").off("click").click(r),
    $("#renameDialog").modal("show"))
});
$("input[id=imageUploadFile]").change(function() {
    assetFileUploadChanged("imageUploadFile", "imageUploadForm", "/Img", function() {
        populateImageAssets()
    })
});
$("input[id=soundUploadFile]").change(function() {
    assetFileUploadChanged("soundUploadFile", "soundUploadForm", "/Snd", function() {
        populateSoundAssets()
    })
});
$("input[id=htmlUploadFile]").change(function() {
    assetFileUploadChanged("htmlUploadFile", "htmlUploadForm", "/Html", function() {
        populateHtmlAssets()
    })
});
$("input[id=miscUploadFile]").change(function() {
    assetFileUploadChanged("miscUploadFile", "miscUploadForm", "/Misc", function() {
        populateMiscAssets()
    })
});
$(document).on("click", "#sampleButton", function() {
    var i = $(this).closest("div"), r = i.data("title"), n = i.data("type"), t, u;
    currentSample = r;
    t = "";
    t = n == "h" ? ".html" : n == "dsj" ? ".dsj" : ".js";
    u = r.split(" ").join("_") + t;
    ajaxGet({
        url: getServerUrl("ide?cmd=get&file=/assets/user/samples/" + u)
    }).then(function(t) {
        var i = t.replace(/\\\'/g, ""), r;
        i = JSON.parse(i).file;
        sampleEditor.hide();
        sampleBlocklyEditor.hide();
        $("#sampleCodeView").show();
        r = $("#sampleToolBar").outerHeight(!0);
        $("#sampleEditor").css("top", r);
        $("#sampleBlocklyEditor").css("top", r);
        $("#sampleContentView").hide();
        n === "dsj" ? (sampleBlocklyEditor.show(),
        sampleBlocklyEditor.loadWorkspace(i),
        sampleBlocklyEditor.resize()) : (sampleEditor.show(),
        sampleEditor.setValue(i),
        sampleEditor.moveCursorTo(0, 0))
    })
});
$(document).on("click", "#newApp .thumbnail", function() {
    newApp("js")
});
$(document).on("click", "#newHtmlApp .thumbnail", function() {
    newApp("html")
});
$(document).on("click", "#newDSJApp .thumbnail", function() {
    newApp("dsj")
});
$(document).on("click", "#openAppButton", function() {
    var i = $(this).closest("li"), t = i.data("appName"), n;
    if (t) {
        if (n = AppList.getApp(t),
        AppList.getOpenApp() == n) {
            $('#leftPanelTabs a[href="#editorTab"]').tab("show");
            return
        }
        AppList.getOpenApp() != null && AppList.getOpenApp().isModified() ? ($("#yesNoCancelDialogHeader").text("Unsaved Changes"),
        $("#yesNoCancelDialogMessage").text("There are unsaved changes, do you want to save changes before continuing?"),
        $("#yesNoCancelDialogYesButton").off("click").click(function() {
            saveAll().then(function() {
                openApp(n)
            })
        }),
        $("#yesNoCancelDialogNoButton").off("click").click(function() {
            chromeApp.discardLocalAppChanges(AppList.getOpenApp().getName());
            openApp(n)
        }),
        $("#yesNoCancelDialog").modal("show")) : openApp(n)
    }
});
$(document).on("click", "#renameAppButton", function() {
    var n = $(this).closest("li"), t = n.data("appName"), i;
    t && ($("#renameDialogName").val(t),
    i = function() {
        var u, r, i, f;
        if ($("#renameDialogName").val() != "") {
            if (u = t,
            r = $("#renameDialogName").val(),
            containsReservedCharacters(r)) {
                $("#renameError").fadeIn();
                return
            }
            if ($("#renameDialog").modal("hide"),
            r == u)
                return;
            typeof AppList.getApp(r) != "undefined" ? ($("#messageDialogHeader").text("Cannot Rename App"),
            $("#messageDialogMessage").text("An App with the name '" + r + "' already exists."),
            $("#messageDialog").modal("show")) : (i = AppList.getApp(t),
            f = AppList.getOpenApp() == i,
            i.rename(r).then(function() {
                AppList.removeApp(u);
                AppList.addApp(i);
                n.data("appName", r);
                f && ($('#editorTabs a[href="' + i.mainEditorFile.tabId + '"]').text(i.mainEditorFile.filename),
                AppList.setOpenApp(i));
                n.find("p.appFilename").text(i.getName());
                loadExternalImage(getServerUrl(i.getIconPath()), n.find("img.app-image"));
                sortAppList()
            }, function() {
                $("#errorDialog").modal("hide")
            }))
        } else
            $("#renameDialog").modal("hide")
    }
    ,
    $("#renameDialogButton").off("click").click(i),
    $("#renameDialog").modal("show"))
});
$(document).on("click", "#deleteAppButton", function() {
    var i = $(this).closest("li"), n = i.data("appName"), t;
    n && (t = AppList.getApp(n),
    AppList.getOpenApp() == t ? ($("#messageDialogHeader").text("Cannot Delete App"),
    $("#messageDialogMessage").text("'" + n + "' is currently open for edit and cannot be deleted."),
    $("#messageDialog").modal("show")) : ($("#okCancelDialogOkButton").off("click").click(function() {
        t.delete().then(function() {
            i.remove()
        })
    }),
    $("#okCancelDialogHeader").text("Delete App"),
    $("#okCancelDialogMessage").text("Are you sure you want to delete the App '" + n + "' and all its assets?"),
    $("#okCancelDialog").modal("show")))
});
$(document).on("click", ".deleteFileBtn", function() {
    var r = $(this).closest("li"), t = r.data("editorFile"), n, i;
    typeof t != "undefined" && (n = AppList.getOpenApp(),
    i = function() {
        ajaxGet({
            url: getServerUrl("ide?cmd=delete&file=" + encodeURIComponent(n.folder + "/" + t.filename))
        }).then(function() {
            var i = n.editorFiles.indexOf(t);
            i != -1 && (n.editorFiles.splice(i, 1),
            $('#editorTabs a[href="' + t.tabId + '"]').parent().remove(),
            $("#editorTabs").data("tabdrop").layout(),
            n.activeEditorFile == t && (i >= n.editorFiles.length && --i,
            $('#editorTabs a[href="' + n.editorFiles[i].tabId + '"]').tab("show")))
        })
    }
    ,
    $("#okCancelDialogHeader").text("Delete File"),
    $("#okCancelDialogMessage").text("Delete '" + t.filename + "', are you sure?"),
    $("#okCancelDialogOkButton").off("click").click(i),
    $("#okCancelDialog").modal("show"))
});
$("#fileTypeOptions li a").click(function() {
    var n = $(this).text();
    $("#fileTypeChoice").html(n)
});
DroidScriptApp.prototype.getName = function() {
    return this.folder
}
;
DroidScriptApp.prototype.getIconPath = function() {
    return this.folder + "/Img/" + this.folder + ".png"
}
;
DroidScriptApp.prototype.isModified = function() {
    for (var n = 0; n < this.editorFiles.length; ++n)
        if (this.editorFiles[n].modified)
            return !0;
    return !1
}
;
DroidScriptApp.prototype.getEditorFileForTab = function(n) {
    for (var t = 0; t < this.editorFiles.length; ++t)
        if (this.editorFiles[t].tabId == n)
            return this.editorFiles[t];
    return null
}
;
DroidScriptApp.prototype.getEditorFileForFilename = function(n) {
    for (var t = 0; t < this.editorFiles.length; ++t)
        if (this.editorFiles[t].filename == n)
            return this.editorFiles[t];
    return null
}
;
DroidScriptApp.prototype.getEditorFilePath = function(n) {
    return this.folder + "/" + n.filename
}
;
DroidScriptApp.prototype.getType = function() {
    return this.mainEditorFile.getType()
}
;
DroidScriptApp.prototype.close = function() {
    for (var n = 0; n < this.editorFiles.length; ++n)
        this.editorFiles[n].close()
}
;
DroidScriptApp.prototype.rename = function(n) {
    var t = this;
    return new Promise(function(i, r) {
        ajaxGet({
            url: getServerUrl("ide?cmd=rename&file=" + encodeURIComponent(t.folder) + "&newname=" + encodeURIComponent(n))
        }).then(function() {
            t.folder = n;
            var i = n + "/" + t.mainEditorFile.filename
              , r = n + "/" + n + "." + t.mainEditorFile.getType();
            return ajaxGet({
                url: getServerUrl("ide?cmd=rename&file=" + encodeURIComponent(i) + "&newname=" + encodeURIComponent(r))
            })
        }).then(function() {
            t.mainEditorFile.displayName = n;
            t.mainEditorFile.filename = n + "." + t.mainEditorFile.getType();
            i()
        }, r)
    }
    )
}
;
DroidScriptApp.prototype.delete = function() {
    var n = this.getName();
    return new Promise(function(t, i) {
        ajaxGet({
            url: getServerUrl("ide?cmd=delete&file=" + encodeURIComponent(n))
        }).then(t, i)
    }
    )
}
