
//Se llama cuando se inicia la aplicación.
function OnStart()
{
	//Cree un diseño con objetos centrados verticalmente.
	lay = app.CreateLayout( "linear", "VCenter,FillXY" );	

	//Cree la imagen 1/5 del ancho de la pantalla y la relación de aspecto correcta.
	img = app.CreateImage( "/Sys/Img/Hello.png", 0.2, -1 );
	lay.AddChild( img );
	
	//Cree un botón 1/3 de ancho de pantalla y 1/10 de altura de pantalla.
	btn = app.CreateButton( "Presioname", 0.3, 0.1 );
	btn.SetMargins( 0, 0.05, 0, 0 );
	lay.AddChild( btn );
	
	//Ajustar la función para llamar cuando se pulsa el botón. 
	btn.SetOnTouch( btn_OnTouch );
	
	//Añadir diseño a la aplicación. 	
	app.AddLayout( lay );
}

//Se llama cuando el usuario toca el botón.
function btn_OnTouch()
{
	//Mostrar un mensaje emergente.
	app.ShowPopup( "Hola Mundo!" );
	
	//Vibrar el teléfono con un patrón (en milisegundos).
	//pause,vibrate,pause,vibrate...
	app.Vibrate( "0,100,30,100,50,300" );
}